package ProxyServer;
import java.net.*;
import java.io.*;
import java.util.*;
import java.lang.*;
import StartAllServers.Debug;
import StartAllServers.*;

public class ProxyServer {
    //I don't care if this is truly synchronized
    public static boolean HAVE_INTERNET = true;
   
    public ProxyServer() {
	 ServerSocket serverSock = null;
	 boolean listening = true;
	 int option = 0;
	 int server_port = StartAllServers.PROXY_SERVER_PORT;  //can change this to anything you want (almost)
    
	 //try to create a server socket
	try {
	    serverSock = new ServerSocket(server_port);
	} catch (IOException e) {
	    System.err.println("Port " + server_port + " is busy, " + e.getMessage());
	    System.exit(2);
	}
	
	Socket client_to_proxySock = null;

	/*****************ADDED CODE************************/
	//check to see if you should go through user history
	boolean histval = StartAllServers.HISTORY;
	if(histval){
	    if (Debug.DEBUG_ProxyServer == true) { 
		System.out.println("Accepting Connections on port "+ server_port); 
	    }
	    try {
		System.out.println("SOCK");
		client_to_proxySock = new Socket("localhost", server_port);
		System.out.println("SOCK OFF");Emacs\emacs-20.7\bin
	    } catch (IOException e) {
		System.err.println("Not accepting because " + e.getMessage());
	    }
	    
	    //make a new Thread to carry out each request
	    if (Debug.DEBUG_ProxyServer == true) { 
		System.out.println("The socket in proxy is:" + client_to_proxySock); 
	    }
	    
	    //Query on every url in the user history file
	    try{
		FileInputStream in = new FileInputStream("/root/.netscape/history.list");
		char ch = 0;
		int size = in.available();
		byte [] b = new byte[size];
		ch = (char)in.read(b);
		StringBuffer result = new StringBuffer("");
		for(int i =0; i<size; i++)
		    result.append((char)b[i]);
		String history = result.toString();
		StringTokenizer tok = new StringTokenizer(history, "\n");
		while(tok.hasMoreTokens()){
		    String token = tok.nextToken();
		    if(token.startsWith("http://")){
			new ServeThread(client_to_proxySock, option, histval, token).start();	  
		    }
		}
	    }
	    catch(Exception e){
		System.out.println(e);
	    }       	
	}
	/***********************************************/
	//listen for clients
	while (listening) {
	    client_to_proxySock = null;
if (Debug.DEBUG_ProxyServer == true) { 
 	 System.out.println("Accepting Connections on port "+ server_port); 
 	}
	    try {
		client_to_proxySock = serverSock.accept();
	    } catch (IOException e) {
	    System.err.println("Not accepting because " + e.getMessage());
	    }
	    
	    //make a new Thread to carry out each request
	    if (Debug.DEBUG_ProxyServer == true) { 
		System.out.println("The socket in proxy is:" + client_to_proxySock); 
	    }
		new ServeThread(client_to_proxySock, option).start();	  
	    }
    
	//close the server socket
	try {
	    serverSock.close();
	} catch (IOException e) {
	    System.err.println("Can't close because " + e.getMessage());
	}
    }


    //good to keep for testing
    public static void main(String[] args) {
	 ServerSocket serverSock = null;
	 boolean listening = true;
	 int option = 0;
	 int server_port = StartAllServers.PROXY_SERVER_PORT;  //can change this to anything you want (almost)
    
	 //try to create a server socket
	try {
	    serverSock = new ServerSocket(server_port);
	} catch (IOException e) {
	    System.err.println("Port " + server_port + " is busy, " + e.getMessage());
	    System.exit(2);
	}
	
	//listen for clients
	while (listening) {
	    Socket client_to_proxySock = null;
if (Debug.DEBUG_ProxyServer == true) { 
 	 System.out.println("Accepting Connections on port "+ server_port); 
 	}
	    try {
		client_to_proxySock = serverSock.accept();
	    } catch (IOException e) {
	    System.err.println("Not accepting because " + e.getMessage());
	    }
	    
	    //make a new Thread to carry out each request
if (Debug.DEBUG_ProxyServer == true) { 
 	 System.out.println("The socket in proxy is:" + client_to_proxySock); 
 	}
	    new ServeThread(client_to_proxySock, option).start();
	  
	    
	}
	//close the server socket
	try {
	    serverSock.close();
	} catch (IOException e) {
	    System.err.println("Can't close because " + e.getMessage());
	}
    }
			   
}
    
			       

    

